## libgbinder 1.1.42

=== Makefile ===
# -*- Mode: makefile-gmake -*-
#
# LIBGLIBUTIL_PATH can be defined to point to libglibutil root directory
# for side-by-side build.
#

.PHONY: clean all debug release test
.PHONY: print_debug_so print_release_so
.PHONY: print_debug_lib print_release_lib print_coverage_lib
.PHONY: print_debug_link print_release_link
.PHONY: print_debug_path print_release_path

#
# Library version
#

VERSION_MAJOR = 1
VERSION_MINOR = 1
VERSION_RELEASE = 42

# Version for pkg-config
PCVERSION = $(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_RELEASE)

#
# Default target
#

all: debug release pkgconfig

#
# Required packages
#

PKGS = glib-2.0 gobject-2.0

ifeq ($(LIBGLIBUTIL_PATH),)

# Assume that libglibutil devel package is installed
PKGS += libglibutil

else

# Side-by-side build
INCLUDES += -I$(LIBGLIBUTIL_PATH)/include
DEBUG_LIBS = -L$(LIBGLIBUTIL_PATH)/build/debug -lglibutil
RELEASE_LIBS = -L$(LIBGLIBUTIL_PATH)/build/release -lglibutil
DEBUG_DEPS = libglibutil_debug
RELEASE_DEPS = libglibutil_release

.PHONY: libglibutil_debug libglibutil_release

libglibutil_debug:
	$(MAKE) -C $(LIBGLIBUTIL_PATH) debug

libglibutil_release:
	$(MAKE) -C $(LIBGLIBUTIL_PATH) release

endif

#
# Library name
#

NAME = gbinder
LIB_NAME = lib$(NAME)
LIB_DEV_SYMLINK = $(LIB_NAME).so
LIB_SYMLINK1 = $(LIB_DEV_SYMLINK).$(VERSION_MAJOR)
LIB_SYMLINK2 = $(LIB_SYMLINK1).$(VERSION_MINOR)
LIB_SONAME = $(LIB_SYMLINK1)
LIB_SO = $(LIB_SONAME).$(VERSION_MINOR).$(VERSION_RELEASE)
LIB = $(LIB_NAME).a

#
# Sources
#

SRC = \
  gbinder_bridge.c \
  gbinder_buffer.c \
  gbinder_cleanup.c \
  gbinder_client.c \
  gbinder_config.c \
  gbinder_driver.c \
  gbinder_eventloop.c \
  gbinder_fmq.c \
  gbinder_io_32.c \
  gbinder_io_64.c \
  gbinder_ipc.c \
  gbinder_local_object.c \
  gbinder_local_reply.c \
  gbinder_local_request.c \
  gbinder_log.c \
  gbinder_proxy_object.c \
  gbinder_reader.c \
  gbinder_remote_object.c \
  gbinder_remote_reply.c \
  gbinder_remote_request.c \
  gbinder_rpc_protocol.c \
  gbinder_servicename.c \
  gbinder_servicepoll.c \
  gbinder_writer.c

SRC += \
  gbinder_servicemanager.c \
  gbinder_servicemanager_aidl.c \
  gbinder_servicemanager_aidl2.c \
  gbinder_servicemanager_aidl3.c \
  gbinder_servicemanager_aidl4.c \
  gbinder_servicemanager_hidl.c

SRC += \
  gbinder_system.c

#
# Directories
#

SRC_DIR = src
INCLUDE_DIR = include
BUILD_DIR = build
DEBUG_BUILD_DIR = $(BUILD_DIR)/debug
RELEASE_BUILD_DIR = $(BUILD_DIR)/release
COVERAGE_BUILD_DIR = $(BUILD_DIR)/coverage

#
# Tools and flags
#

PKG_CONFIG ?= pkg-config
CC ?= $(CROSS_COMPILE)gcc
STRIP ?= strip
LD = $(CC)
WARNINGS = -Wall -Wstrict-aliasing -Wunused-result
DEFINES += -DGLIB_VERSION_MAX_ALLOWED=GLIB_VERSION_2_32 \
  -DGLIB_VERSION_MIN_REQUIRED=GLIB_VERSION_MAX_ALLOWED
INCLUDES += -I$(INCLUDE_DIR)
BASE_FLAGS = -fPIC
FULL_CFLAGS = $(BASE_FLAGS) $(CFLAGS) $(DEFINES) $(WARNINGS) $(INCLUDES) \
  -MMD -MP $(shell $(PKG_CONFIG) --cflags $(PKGS))
FULL_LDFLAGS = $(BASE_FLAGS) $(LDFLAGS) -shared -Wl,-soname,$(LIB_SONAME) \
  $(shell $(PKG_CONFIG) --libs $(PKGS)) -lpthread
DEBUG_FLAGS = -g
RELEASE_FLAGS =
COVERAGE_FLAGS = -g

KEEP_SYMBOLS ?= 0
ifneq ($(KEEP_SYMBOLS),0)
RELEASE_FLAGS += -g
endif

DEBUG_LDFLAGS = $(FULL_LDFLAGS) $(DEBUG_LIBS) $(DEBUG_FLAGS)
RELEASE_LDFLAGS = $(FULL_LDFLAGS) $(RELEASE_LIBS) $(RELEASE_FLAGS)
DEBUG_CFLAGS = $(FULL_CFLAGS) $(DEBUG_FLAGS) -DDEBUG
RELEASE_CFLAGS = $(FULL_CFLAGS) $(RELEASE_FLAGS) -O2
COVERAGE_CFLAGS = $(FULL_CFLAGS) $(COVERAGE_FLAGS) --coverage

#
# Files
#

PKGCONFIG = $(BUILD_DIR)/$(LIB_NAME).pc
DEBUG_OBJS = $(SRC:%.c=$(DEBUG_BUILD_DIR)/%.o)
RELEASE_OBJS = $(SRC:%.c=$(RELEASE_BUILD_DIR)/%.o)
COVERAGE_OBJS = $(SRC:%.c=$(COVERAGE_BUILD_DIR)/%.o)

DEBUG_SO = $(DEBUG_BUILD_DIR)/$(LIB_SO)
RELEASE_SO = $(RELEASE_BUILD_DIR)/$(LIB_SO)
DEBUG_LINK = $(DEBUG_BUILD_DIR)/$(LIB_SYMLINK1)
RELEASE_LINK = $(RELEASE_BUILD_DIR)/$(LIB_SYMLINK1)
DEBUG_DEV_LINK = $(DEBUG_BUILD_DIR)/$(LIB_DEV_SYMLINK)
RELEASE_DEV_LINK = $(RELEASE_BUILD_DIR)/$(LIB_DEV_SYMLINK)
DEBUG_LIB = $(DEBUG_BUILD_DIR)/$(LIB)
RELEASE_LIB = $(RELEASE_BUILD_DIR)/$(LIB)
COVERAGE_LIB = $(COVERAGE_BUILD_DIR)/$(LIB)

#
# Dependencies
#

DEPS = $(DEBUG_OBJS:%.o=%.d) $(RELEASE_OBJS:%.o=%.d)
ifneq ($(MAKECMDGOALS),clean)
ifneq ($(strip $(DEPS)),)
-include $(DEPS)
endif
endif

$(PKGCONFIG): | $(BUILD_DIR)
$(DEBUG_OBJS) $(DEBUG_SO): | $(DEBUG_BUILD_DIR) $(DEBUG_DEPS)
$(RELEASE_OBJS) $(RELEASE_SO): | $(RELEASE_BUILD_DIR) $(RELEASE_DEPS)
$(COVERAGE_OBJS) $(COVERAGE_LIB): | $(COVERAGE_BUILD_DIR)

$(DEBUG_LINK): | $(DEBUG_LIB)
$(RELEASE_LINK): | $(RELEASE_LIB)
$(DEBUG_DEV_LINK): | $(DEBUG_LINK)
$(RELEASE_DEV_LINK): | $(RELEASE_LINK)

#
# Rules
#

debug: $(DEBUG_SO) $(DEBUG_LINK) $(DEBUG_DEV_LINK)

release: $(RELEASE_SO) $(RELEASE_LINK) $(RELEASE_DEV_LINK)

debug_lib: $(DEBUG_LIB)

release_lib: $(RELEASE_LIB)

coverage_lib: $(COVERAGE_LIB)

pkgconfig: $(PKGCONFIG)

print_debug_so:
	@echo $(DEBUG_SO)

print_release_so:
	@echo $(RELEASE_SO)

print_debug_lib:
	@echo $(DEBUG_LIB)

print_release_lib:
	@echo $(RELEASE_LIB)

print_coverage_lib:
	@echo $(COVERAGE_LIB)

print_debug_link:
	@echo $(DEBUG_LINK)

print_release_link:
	@echo $(RELEASE_LINK)

print_debug_path:
	@echo $(DEBUG_BUILD_DIR)

print_release_path:
	@echo $(RELEASE_BUILD_DIR)

clean:
	$(MAKE) -C test clean
	$(MAKE) -C unit clean
	rm -fr test/coverage/results test/coverage/*.gcov
	rm -f *~ $(SRC_DIR)/*~ $(INCLUDE_DIR)/*~
	rm -fr $(BUILD_DIR) RPMS installroot
	rm -fr debian/tmp debian/libgbinder debian/libgbinder-dev
	rm -f documentation.list debian/files debian/*.substvars
	rm -f debian/*.debhelper.log debian/*.debhelper debian/*~
	rm -f debian/libgbinder.install debian/libgbinder-dev.install

test:
	$(MAKE) -C unit test

$(BUILD_DIR):
	mkdir -p $@

$(DEBUG_BUILD_DIR):
	mkdir -p $@

$(RELEASE_BUILD_DIR):
	mkdir -p $@

$(COVERAGE_BUILD_DIR):
	mkdir -p $@

$(DEBUG_BUILD_DIR)/%.o : $(SRC_DIR)/%.c
	$(CC) -c $(DEBUG_CFLAGS) -MT"$@" -MF"$(@:%.o=%.d)" $< -o $@

$(RELEASE_BUILD_DIR)/%.o : $(SRC_DIR)/%.c
	$(CC) -c $(RELEASE_CFLAGS) -MT"$@" -MF"$(@:%.o=%.d)" $< -o $@

$(COVERAGE_BUILD_DIR)/%.o : $(SRC_DIR)/%.c
	$(CC) -c $(COVERAGE_CFLAGS) -MT"$@" -MF"$(@:%.o=%.d)" $< -o $@

$(DEBUG_SO): $(DEBUG_OBJS)
	$(LD) $(DEBUG_OBJS) $(DEBUG_LDFLAGS) -o $@

$(RELEASE_SO): $(RELEASE_OBJS)
	$(LD) $(RELEASE_OBJS) $(RELEASE_LDFLAGS) -o $@
ifeq ($(KEEP_SYMBOLS),0)
	$(STRIP) $@
endif

$(DEBUG_LIB): $(DEBUG_OBJS)
	$(AR) rc $@ $?
	ranlib $@

$(RELEASE_LIB): $(RELEASE_OBJS)
	$(AR) rc $@ $?
	ranlib $@

$(DEBUG_LINK):
	ln -sf $(LIB_SO) $@

$(RELEASE_LINK):
	ln -sf $(LIB_SO) $@

$(DEBUG_DEV_LINK):
	ln -sf $(LIB_SYMLINK1) $@

$(RELEASE_DEV_LINK):
	ln -sf $(LIB_SYMLINK1) $@

$(COVERAGE_LIB): $(COVERAGE_OBJS)
	$(AR) rc $@ $?
	ranlib $@

#
# LIBDIR usually gets substituted with arch specific dir.
# It's relative in deb build and can be whatever in rpm build.
#

LIBDIR ?= usr/lib
ABS_LIBDIR := $(shell echo /$(LIBDIR) | sed -r 's|/+|/|g')

$(PKGCONFIG): $(LIB_NAME).pc.in Makefile
	sed -e 's|@version@|$(PCVERSION)|g' -e 's|@libdir@|$(ABS_LIBDIR)|g' $< > $@

debian/%.install: debian/%.install.in
	sed 's|@LIBDIR@|$(LIBDIR)|g' $< > $@

#
# Install
#

INSTALL_PERM  = 644

INSTALL = install
INSTALL_DIRS = $(INSTALL) -d
INSTALL_FILES = $(INSTALL) -m $(INSTALL_PERM)

INSTALL_LIB_DIR = $(DESTDIR)$(ABS_LIBDIR)
INSTALL_INCLUDE_DIR = $(DESTDIR)/usr/include/$(NAME)
INSTALL_PKGCONFIG_DIR = $(DESTDIR)$(ABS_LIBDIR)/pkgconfig

install: $(INSTALL_LIB_DIR)
	$(INSTALL) -m 755 $(RELEASE_SO) $(INSTALL_LIB_DIR)
	ln -sf $(LIB_SO) $(INSTALL_LIB_DIR)/$(LIB_SYMLINK2)
	ln -sf $(LIB_SYMLINK2) $(INSTALL_LIB_DIR)/$(LIB_SYMLINK1)

install-dev: install $(INSTALL_INCLUDE_DIR) $(INSTALL_PKGCONFIG_DIR)
	$(INSTALL_FILES) $(INCLUDE_DIR)/*.h $(INSTALL_INCLUDE_DIR)
	$(INSTALL_FILES) $(PKGCONFIG) $(INSTALL_PKGCONFIG_DIR)
	ln -sf $(LIB_SYMLINK1) $(INSTALL_LIB_DIR)/$(LIB_DEV_SYMLINK)

$(INSTALL_LIB_DIR):
	$(INSTALL_DIRS) $@

$(INSTALL_INCLUDE_DIR):
	$(INSTALL_DIRS) $@

$(INSTALL_PKGCONFIG_DIR):
	$(INSTALL_DIRS) $@

=== test/Makefile ===
# -*- Mode: makefile-gmake -*-

all:
%:
	@$(MAKE) -C binder-bridge $*
	@$(MAKE) -C binder-client $*
	@$(MAKE) -C binder-dump $*
	@$(MAKE) -C binder-list $*
	@$(MAKE) -C binder-ping $*
	@$(MAKE) -C binder-service $*
	@$(MAKE) -C binder-call $*
	@$(MAKE) -C rild-card-status $*

=== unit/Makefile ===
# -*- Mode: makefile-gmake -*-

all:
%:
	@$(MAKE) -C unit_bridge $*
	@$(MAKE) -C unit_buffer $*
	@$(MAKE) -C unit_cleanup $*
	@$(MAKE) -C unit_client $*
	@$(MAKE) -C unit_config $*
	@$(MAKE) -C unit_driver $*
	@$(MAKE) -C unit_eventloop $*
	@$(MAKE) -C unit_fmq $*
	@$(MAKE) -C unit_ipc $*
	@$(MAKE) -C unit_local_object $*
	@$(MAKE) -C unit_local_reply $*
	@$(MAKE) -C unit_local_request $*
	@$(MAKE) -C unit_log $*
	@$(MAKE) -C unit_protocol $*
	@$(MAKE) -C unit_proxy_object $*
	@$(MAKE) -C unit_reader $*
	@$(MAKE) -C unit_remote_object $*
	@$(MAKE) -C unit_remote_reply $*
	@$(MAKE) -C unit_remote_request $*
	@$(MAKE) -C unit_servicemanager $*
	@$(MAKE) -C unit_servicemanager_aidl $*
	@$(MAKE) -C unit_servicemanager_aidl2 $*
	@$(MAKE) -C unit_servicemanager_aidl3 $*
	@$(MAKE) -C unit_servicemanager_aidl4 $*
	@$(MAKE) -C unit_servicemanager_hidl $*
	@$(MAKE) -C unit_servicename $*
	@$(MAKE) -C unit_servicepoll $*
	@$(MAKE) -C unit_writer $*

clean: unitclean
	rm -f coverage/*.gcov
	rm -fr coverage/report

=== test/ashmem-test/Makefile ===
# -*- Mode: makefile-gmake -*-

EXE = ashmem-test

include ../common/Makefile

=== test/binder-bridge/Makefile ===
# -*- Mode: makefile-gmake -*-

EXE = binder-bridge

include ../common/Makefile

=== test/binder-call/Makefile ===
# -*- Mode: makefile-gmake -*-

.PHONY: all debug release install clean cleaner
.PHONY: libgbinder-release libgbinder-debug

#
# Required packages
#

PKGS = glib-2.0 gio-2.0 gio-unix-2.0 libglibutil

#
# Default target
#

all: debug release

#
# Executable
#

EXE = binder-call

#
# Sources
#

SRC = $(EXE).c
GEN_SRC = \
  cmdline.tab.c \
  lex.cmdline.c

#
# Directories
#

SRC_DIR = .
BUILD_DIR = build
GEN_DIR = $(BUILD_DIR)
LIB_DIR = ../..
DEBUG_BUILD_DIR = $(BUILD_DIR)/debug
RELEASE_BUILD_DIR = $(BUILD_DIR)/release

#
# Tools and flags
#

PKG_CONFIG ?= pkg-config
CC ?= $(CROSS_COMPILE)gcc
LD = $(CC)
WARNINGS = -Wall
DEFINES += -DGLIB_VERSION_MAX_ALLOWED=GLIB_VERSION_2_32 \
  -DGLIB_VERSION_MIN_REQUIRED=GLIB_VERSION_MAX_ALLOWED
INCLUDES = -I$(LIB_DIR)/include -I$(GEN_DIR) -I$(SRC_DIR)
CFLAGS += -fPIC $(DEFINES) $(WARNINGS) $(INCLUDES) -MMD -MP \
  $(shell $(PKG_CONFIG) --cflags $(PKGS))
LDFLAGS += -pie $(shell $(PKG_CONFIG) --libs $(PKGS))
QUIET_MAKE = $(MAKE) --no-print-directory
DEBUG_FLAGS = -g
RELEASE_FLAGS =

KEEP_SYMBOLS ?= 0
ifneq ($(KEEP_SYMBOLS),0)
RELEASE_FLAGS += -g
SUBMAKE_OPTS += KEEP_SYMBOLS=1
endif

DEBUG_LDFLAGS = $(LDFLAGS) $(DEBUG_FLAGS)
RELEASE_LDFLAGS = $(LDFLAGS) $(RELEASE_FLAGS)
DEBUG_CFLAGS = $(CFLAGS) $(DEBUG_FLAGS) -DDEBUG
RELEASE_CFLAGS = $(CFLAGS) $(RELEASE_FLAGS) -O2

#
# Files
#

DEBUG_OBJS = \
  $(GEN_SRC:%.c=$(DEBUG_BUILD_DIR)/%.o) \
  $(SRC:%.c=$(DEBUG_BUILD_DIR)/%.o)
RELEASE_OBJS = \
  $(GEN_SRC:%.c=$(RELEASE_BUILD_DIR)/%.o) \
  $(SRC:%.c=$(RELEASE_BUILD_DIR)/%.o)

DEBUG_SO_FILE := $(shell $(QUIET_MAKE) -C $(LIB_DIR) print_debug_so)
RELEASE_SO_FILE := $(shell $(QUIET_MAKE) -C $(LIB_DIR) print_release_so)
DEBUG_LINK_FILE := $(shell $(QUIET_MAKE) -C $(LIB_DIR) print_debug_link)
RELEASE_LINK_FILE := $(shell $(QUIET_MAKE) -C $(LIB_DIR) print_release_link)
DEBUG_SO = $(LIB_DIR)/$(DEBUG_SO_FILE)
RELEASE_SO = $(LIB_DIR)/$(RELEASE_SO_FILE)
GEN_FILES = $(GEN_SRC:%=$(GEN_DIR)/%)
.PRECIOUS: $(GEN_FILES)

#
# Dependencies
#

DEPS = $(DEBUG_OBJS:%.o=%.d) $(RELEASE_OBJS:%.o=%.d)
ifneq ($(MAKECMDGOALS),clean)
ifneq ($(strip $(DEPS)),)
-include $(DEPS)
endif
endif

$(GEN_FILES): | $(GEN_DIR)
$(DEBUG_OBJS): | $(DEBUG_BUILD_DIR)
$(RELEASE_OBJS): | $(RELEASE_BUILD_DIR)

#
# Rules
#

DEBUG_EXE = $(DEBUG_BUILD_DIR)/$(EXE)
RELEASE_EXE = $(RELEASE_BUILD_DIR)/$(EXE)

debug: libgbinder-debug $(DEBUG_EXE)

release: libgbinder-release $(RELEASE_EXE)

clean:
	rm -f *~
	rm -fr $(BUILD_DIR)

cleaner: clean
	@$(MAKE) -C $(LIB_DIR) clean

$(DEBUG_BUILD_DIR):
	mkdir -p $@

$(RELEASE_BUILD_DIR):
	mkdir -p $@

$(GEN_DIR):
	mkdir -p $@

$(GEN_DIR)/%.tab.c : $(SRC_DIR)/%.y
	bison -pcmdline -bcmdline -d -o $@ $<

$(GEN_DIR)/lex.%.c : $(SRC_DIR)/%.l
	flex -o $@ $<

$(DEBUG_BUILD_DIR)/%.o : $(GEN_DIR)/%.c
	$(CC) -c $(DEBUG_CFLAGS) -MT"$@" -MF"$(@:%.o=%.d)" $< -o $@

$(RELEASE_BUILD_DIR)/%.o : $(GEN_DIR)/%.c
	$(CC) -c $(RELEASE_CFLAGS) -MT"$@" -MF"$(@:%.o=%.d)" $< -o $@

$(DEBUG_BUILD_DIR)/%.o : $(SRC_DIR)/%.c
	$(CC) -c $(DEBUG_CFLAGS) -MT"$@" -MF"$(@:%.o=%.d)" $< -o $@

$(RELEASE_BUILD_DIR)/%.o : $(SRC_DIR)/%.c
	$(CC) -c $(RELEASE_CFLAGS) -MT"$@" -MF"$(@:%.o=%.d)" $< -o $@

$(DEBUG_EXE): $(DEBUG_SO) $(DEBUG_BUILD_DIR) $(DEBUG_OBJS)
	$(LD) $(DEBUG_OBJS) $(DEBUG_LDFLAGS) $< -o $@

$(RELEASE_EXE): $(RELEASE_SO) $(RELEASE_BUILD_DIR) $(RELEASE_OBJS)
	$(LD) $(RELEASE_OBJS) $(RELEASE_LDFLAGS) $< -o $@
ifeq ($(KEEP_SYMBOLS),0)
	strip $@
endif

libgbinder-debug:
	@$(MAKE) $(SUBMAKE_OPTS) -C $(LIB_DIR) $(DEBUG_SO_FILE) $(DEBUG_LINK_FILE)

libgbinder-release:
	@$(MAKE) $(SUBMAKE_OPTS) -C $(LIB_DIR) $(RELEASE_SO_FILE) $(RELEASE_LINK_FILE)

#
# Install
#

INSTALL = install

INSTALL_BIN_DIR = $(DESTDIR)/usr/bin

install: release $(INSTALL_BIN_DIR)
	$(INSTALL) -m 755 $(RELEASE_EXE) $(INSTALL_BIN_DIR)

$(INSTALL_BIN_DIR):
	$(INSTALL) -d $@

=== test/binder-client/Makefile ===
# -*- Mode: makefile-gmake -*-

EXE = binder-client

include ../common/Makefile

=== test/binder-dump/Makefile ===
# -*- Mode: makefile-gmake -*-

EXE = binder-dump

include ../common/Makefile

=== test/binder-list/Makefile ===
# -*- Mode: makefile-gmake -*-

EXE = binder-list

include ../common/Makefile

=== test/binder-ping/Makefile ===
# -*- Mode: makefile-gmake -*-

EXE = binder-ping

include ../common/Makefile

=== test/binder-service/Makefile ===
# -*- Mode: makefile-gmake -*-

EXE = binder-service

include ../common/Makefile

=== test/common/Makefile ===
# -*- Mode: makefile-gmake -*-

.PHONY: all debug release install clean cleaner
.PHONY: libgbinder-release libgbinder-debug

#
# Executable must be defined
#

ifndef EXE
${error EXE not defined}
endif

#
# Required packages
#

PKGS = glib-2.0 gio-2.0 gio-unix-2.0 libglibutil

#
# Default target
#

all: debug release

#
# Sources
#

SRC ?= $(EXE).c

#
# Directories
#

SRC_DIR = .
BUILD_DIR = build
LIB_DIR = ../..
DEBUG_BUILD_DIR = $(BUILD_DIR)/debug
RELEASE_BUILD_DIR = $(BUILD_DIR)/release

#
# Tools and flags
#

PKG_CONFIG ?= pkg-config
CC ?= $(CROSS_COMPILE)gcc
LD = $(CC)
WARNINGS = -Wall
DEFINES += -DGLIB_VERSION_MAX_ALLOWED=GLIB_VERSION_2_32 \
  -DGLIB_VERSION_MIN_REQUIRED=GLIB_VERSION_MAX_ALLOWED
INCLUDES = -I$(LIB_DIR)/include
CFLAGS += -fPIC $(DEFINES) $(WARNINGS) $(INCLUDES) -MMD -MP \
  $(shell $(PKG_CONFIG) --cflags $(PKGS))
LDFLAGS += -pie $(shell $(PKG_CONFIG) --libs $(PKGS))
QUIET_MAKE = $(MAKE) --no-print-directory
DEBUG_FLAGS = -g
RELEASE_FLAGS =

KEEP_SYMBOLS ?= 0
ifneq ($(KEEP_SYMBOLS),0)
RELEASE_FLAGS += -g
SUBMAKE_OPTS += KEEP_SYMBOLS=1
endif

DEBUG_LDFLAGS = $(LDFLAGS) $(DEBUG_FLAGS)
RELEASE_LDFLAGS = $(LDFLAGS) $(RELEASE_FLAGS)
DEBUG_CFLAGS = $(CFLAGS) $(DEBUG_FLAGS) -DDEBUG
RELEASE_CFLAGS = $(CFLAGS) $(RELEASE_FLAGS) -O2

#
# Files
#

DEBUG_OBJS = $(SRC:%.c=$(DEBUG_BUILD_DIR)/%.o)
RELEASE_OBJS = $(SRC:%.c=$(RELEASE_BUILD_DIR)/%.o)
DEBUG_SO_FILE := $(shell $(QUIET_MAKE) -C $(LIB_DIR) print_debug_so)
RELEASE_SO_FILE := $(shell $(QUIET_MAKE) -C $(LIB_DIR) print_release_so)
DEBUG_LINK_FILE := $(shell $(QUIET_MAKE) -C $(LIB_DIR) print_debug_link)
RELEASE_LINK_FILE := $(shell $(QUIET_MAKE) -C $(LIB_DIR) print_release_link)
DEBUG_SO = $(LIB_DIR)/$(DEBUG_SO_FILE)
RELEASE_SO = $(LIB_DIR)/$(RELEASE_SO_FILE)

#
# Dependencies
#

DEPS = $(DEBUG_OBJS:%.o=%.d) $(RELEASE_OBJS:%.o=%.d)
ifneq ($(MAKECMDGOALS),clean)
ifneq ($(strip $(DEPS)),)
-include $(DEPS)
endif
endif

$(DEBUG_OBJS): | $(DEBUG_BUILD_DIR)
$(RELEASE_OBJS): | $(RELEASE_BUILD_DIR)

#
# Rules
#

DEBUG_EXE = $(DEBUG_BUILD_DIR)/$(EXE)
RELEASE_EXE = $(RELEASE_BUILD_DIR)/$(EXE)

debug: libgbinder-debug $(DEBUG_EXE)

release: libgbinder-release $(RELEASE_EXE)

clean:
	rm -f *~
	rm -fr $(BUILD_DIR)

cleaner: clean
	@$(MAKE) -C $(LIB_DIR) clean

$(DEBUG_BUILD_DIR):
	mkdir -p $@

$(RELEASE_BUILD_DIR):
	mkdir -p $@

$(DEBUG_BUILD_DIR)/%.o : $(SRC_DIR)/%.c
	$(CC) -c $(DEBUG_CFLAGS) -MT"$@" -MF"$(@:%.o=%.d)" $< -o $@

$(RELEASE_BUILD_DIR)/%.o : $(SRC_DIR)/%.c
	$(CC) -c $(RELEASE_CFLAGS) -MT"$@" -MF"$(@:%.o=%.d)" $< -o $@

$(DEBUG_EXE): $(DEBUG_SO) $(DEBUG_BUILD_DIR) $(DEBUG_OBJS)
	$(LD) $(DEBUG_OBJS) $(DEBUG_LDFLAGS) $< -o $@

$(RELEASE_EXE): $(RELEASE_SO) $(RELEASE_BUILD_DIR) $(RELEASE_OBJS)
	$(LD) $(RELEASE_OBJS) $(RELEASE_LDFLAGS) $< -o $@
ifeq ($(KEEP_SYMBOLS),0)
	strip $@
endif

libgbinder-debug:
	@$(MAKE) $(SUBMAKE_OPTS) -C $(LIB_DIR) $(DEBUG_SO_FILE) $(DEBUG_LINK_FILE)

libgbinder-release:
	@$(MAKE) $(SUBMAKE_OPTS) -C $(LIB_DIR) $(RELEASE_SO_FILE) $(RELEASE_LINK_FILE)

#
# Install
#

INSTALL = install

INSTALL_BIN_DIR = $(DESTDIR)/usr/bin

install: release $(INSTALL_BIN_DIR)
	$(INSTALL) -m 755 $(RELEASE_EXE) $(INSTALL_BIN_DIR)

$(INSTALL_BIN_DIR):
	$(INSTALL) -d $@

=== debian/changelog ===
libgbinder (1.1.42) unstable; urgency=low

  * Delete name watches with no handlers
  * Register for sm notifications asynchronously
  * Correct stability field wire format on Android 12

 -- Slava Monich <slava@monich.com>  Wed, 11 Dec 2024 06:40:00 +0200

libgbinder (1.1.41) unstable; urgency=low

  * Fix sending NULL binder object
  * Added gbinder_reader_read_nullable_string8
  * Check if counted strings are NULL-terminated

 -- Slava Monich <slava@monich.com>  Sat, 02 Nov 2024 05:13:22 +0200

libgbinder (1.1.40) unstable; urgency=low

  * Make stability field of local object configurable
  * Make more unit tests independent on system config
  * Use UNDECLARED stability for NULL binders

 -- Slava Monich <slava@monich.com>  Thu, 18 Jul 2024 05:14:28 +0300

libgbinder (1.1.39) unstable; urgency=low

  * Eliminate defects found by Coverity

 -- Slava Monich <slava@monich.com>  Sun, 05 May 2024 20:03:44 +0300

libgbinder (1.1.38) unstable; urgency=low

  * Fixed byte array padding

 -- Slava Monich <slava@monich.com>  Sat, 02 Mar 2024 02:11:50 +0200

libgbinder (1.1.37) unstable; urgency=low

  * Fixed gbinder_driver_reply_data return value

 -- Slava Monich <slava@monich.com>  Mon, 26 Feb 2024 16:22:29 +0200

libgbinder (1.1.36) unstable; urgency=low

  * Support pkg-config cross-compilation
  * Fixed handling of UTF-16 surrogate pairs

 -- Slava Monich <slava@monich.com>  Sat, 10 Feb 2024 05:04:13 +0200

libgbinder (1.1.35) unstable; urgency=low

  * Make unit tests independent on system config
  * Use MAKE var instead of explicitly calling make

 -- Slava Monich <slava@monich.com>  Thu, 23 Nov 2023 01:42:56 +0200

libgbinder (1.1.34) unstable; urgency=low

  * Fixed binder-call help message
  * Require glib 2.32

 -- Slava Monich <slava@monich.com>  Sun, 30 Apr 2023 06:04:38 +0300

libgbinder (1.1.33) unstable; urgency=low

  * Fixed GBinderWriterType for byte and int32

 -- Slava Monich <slava@monich.com>  Sun, 26 Feb 2023 03:13:49 +0200

libgbinder (1.1.32) unstable; urgency=low

  * Improved reliability of unit tests

 -- Slava Monich <slava@monich.com>  Mon, 23 Jan 2023 11:48:00 +0200

libgbinder (1.1.31) unstable; urgency=low

  * Fixed serialization issues on big-endian
  * Refactored binder simulation for unit tests

 -- Slava Monich <slava@monich.com>  Wed, 04 Jan 2023 19:10:37 +0200

libgbinder (1.1.30) unstable; urgency=low

  * Fixed BC_ACQUIRE_DONE encoding

 -- Slava Monich <slava.monich@jolla.com>  Sun, 04 Dec 2022 19:50:10 +0200

libgbinder (1.1.29) unstable; urgency=low

  * Added gbinder_writer_append_struct_vec

 -- Slava Monich <slava.monich@jolla.com>  Fri, 25 Nov 2022 00:01:41 +0200

libgbinder (1.1.28) unstable; urgency=low

  * Allow to pass negative number as a parameter to binder-call
  * Compile tools as PIE

 -- Slava Monich <slava.monich@jolla.com>  Tue, 22 Nov 2022 18:21:29 +0200

libgbinder (1.1.27) unstable; urgency=low

  * Added gbinder_writer_append_struct()

 -- Slava Monich <slava.monich@jolla.com>  Thu, 17 Nov 2022 03:25:37 +0200

libgbinder (1.1.26) unstable; urgency=low

  * Use BINDER_TYPE_HANDLE for NULL binders
  * Fixed binder object encoding in aidl3 protocol

 -- Slava Monich <slava.monich@jolla.com>  Fri, 14 Oct 2022 16:48:29 +0300

libgbinder (1.1.25) unstable; urgency=low

  * Handle RPC protocol change at run time

 -- Slava Monich <slava.monich@jolla.com>  Tue, 19 Jul 2022 02:02:41 +0300

libgbinder (1.1.24) unstable; urgency=low

  * Bumped debhelper compat level to 7

 -- Slava Monich <slava.monich@jolla.com>  Thu, 14 Jul 2022 01:32:11 +0300

libgbinder (1.1.23) unstable; urgency=low

  * Fixed Debian build dependencies

 -- Slava Monich <slava.monich@jolla.com>  Thu, 23 Jun 2022 20:09:35 +0300

libgbinder (1.1.22) unstable; urgency=low

  * Added support for Android 12 (API level 31)
  * Made binder device configurable for binder-dump

 -- Slava Monich <slava.monich@jolla.com>  Wed, 22 Jun 2022 17:02:20 +0300

libgbinder (1.1.21) unstable; urgency=low

  * Properly finalize GBinderIpc and GBinderServicePoll

 -- Slava Monich <slava.monich@jolla.com>  Mon, 20 Jun 2022 18:53:26 +0300

libgbinder (1.1.20) unstable; urgency=low

  * Made RPC protocol selectable at runtime

 -- Slava Monich <slava.monich@jolla.com>  Sat, 11 Jun 2022 02:49:49 +0300

libgbinder (1.1.19) unstable; urgency=low

  * Added reader and writer for aidl parcelables

 -- Slava Monich <slava.monich@jolla.com>  Sun, 20 Feb 2022 03:26:24 +0200

libgbinder (1.1.18) unstable; urgency=low

  * Disassociate auto-created proxies to stop them from piling up

 -- Slava Monich <slava.monich@jolla.com>  Sat, 08 Jan 2022 15:35:56 +0200

libgbinder (1.1.17) unstable; urgency=low

  * Don't release remote proxy handle too early (sometimes hever)

 -- Slava Monich <slava.monich@jolla.com>  Fri, 07 Jan 2022 14:43:51 +0200

libgbinder (1.1.16) unstable; urgency=low

  * Make sure stale object pointers don't hang around
  * Properly shut down remote object inside the proxy
  * Read ref_count from GObject atomically

 -- Slava Monich <slava.monich@jolla.com>  Mon, 03 Jan 2022 13:58:44 +0200

libgbinder (1.1.15) unstable; urgency=low

  * Added readers and writers for int8 and int16

 -- Slava Monich <slava.monich@jolla.com>  Mon, 27 Dec 2021 15:13:23 +0200

libgbinder (1.1.14) unstable; urgency=low

  * Support for FMQ (Fast Message Queues)
  * Support for Android 11 (API level 30)
  * Made GBinderReader API slightly more NULL tolerant
  * Added gbinder_client_rpc_header()
  * Added gbinder_reader_get_data()
  * Added gbinder_writer_get_data()
  * Added gbinder_servicemanager_device()
  * Added gbinder_local_reply_append_fd()

 -- Slava Monich <slava.monich@jolla.com>  Wed, 24 Nov 2021 17:15:48 +0200

libgbinder (1.1.13) unstable; urgency=low

  * Added gbinder_writer_strdup()
  * Added gbinder_writer_append_hidl_string_copy()
  * Dropped pkgconfig requirement for devel package

 -- Slava Monich <slava.monich@jolla.com>  Thu, 28 Oct 2021 14:31:01 +0300



=== debian/control ===
Source: libgbinder
Section: libs
Priority: optional
Maintainer: Slava Monich <slava.monich@jolla.com>
Build-Depends: debhelper (>= 8.1.3), libglib2.0-dev (>= 2.0), libglibutil-dev (>= 1.0.52), flex, bison
Standards-Version: 3.8.4

Package: libgbinder
Section: libs
Architecture: any
Depends: libglibutil (>= 1.0.52), ${shlibs:Depends}, ${misc:Depends}
Description: Binder client library

Package: libgbinder-dev
Section: libdevel
Architecture: any
Depends: libgbinder (= ${binary:Version}), libglibutil-dev (>= 1.0.52)
Description: Development files for libgbinder

Package: libgbinder-tools
Section: utils
Architecture: any
Depends: libgbinder, ${misc:Depends}
Description: Binder command line utilities

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

LIBDIR=usr/lib/$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

override_dh_auto_build:
	dh_auto_build -- LIBDIR=$(LIBDIR) release pkgconfig debian/libgbinder.install debian/libgbinder-dev.install
	dh_auto_build -- -C test/binder-bridge release
	dh_auto_build -- -C test/binder-call release
	dh_auto_build -- -C test/binder-list release
	dh_auto_build -- -C test/binder-ping release

override_dh_auto_install:
	dh_auto_install -- LIBDIR=$(LIBDIR) install-dev
	dh_auto_install -- -C test/binder-bridge
	dh_auto_install -- -C test/binder-call
	dh_auto_install -- -C test/binder-list
	dh_auto_install -- -C test/binder-ping

%:
	dh $@

## libgbinder 1.1.43

=== debian/changelog ===
libgbinder (1.1.43-0pureos1~byz1) byzantium; urgency=medium

  * Backport to byzantium

 -- Sebastian Krzyszkowiak <sebastian.krzyszkowiak@puri.sm>  Sat, 17 Jan 2026 10:58:51 +0100

libgbinder (1.1.43-0pureos1) crimson; urgency=medium

  * New upstream release
  * d/control: Bump glib dependency to 2.32
  * d/patches: Revert "Use MAKE var instead of explicitly calling make"

 -- Sebastian Krzyszkowiak <sebastian.krzyszkowiak@puri.sm>  Tue, 21 Oct 2025 17:47:37 +0200

libgbinder (1.1.26-0pureos3) byzantium; urgency=medium

  * d/rules: Point LD_LIBRARY_PATH to libgbinder's dir for help2man

 -- Sebastian Krzyszkowiak <sebastian.krzyszkowiak@puri.sm>  Sun, 20 Nov 2022 01:42:55 +0100

libgbinder (1.1.26-0pureos2) byzantium; urgency=medium

  * d/copyright: DEP-5ify
  * debian: Generate manpages with help2man

 -- Sebastian Krzyszkowiak <sebastian.krzyszkowiak@puri.sm>  Mon, 14 Nov 2022 22:44:13 +0100

libgbinder (1.1.26-0pureos1) byzantium; urgency=medium

  * Upload into byzantium

 -- Sebastian Krzyszkowiak <sebastian.krzyszkowiak@puri.sm>  Mon, 07 Nov 2022 22:34:49 +0100

=== debian/control ===
Source: libgbinder
Section: libs
Priority: optional
Maintainer: PureOS Maintainers <pureos-project@lists.puri.sm>
XSBC-Original-Maintainer: Slava Monich <slava.monich@jolla.com>
Build-Depends: debhelper-compat (= 13), libglib2.0-dev (>= 2.32), libglibutil-dev (>= 1.0.52), flex, bison, help2man
Standards-Version: 4.5.1
Rules-Requires-Root: no
Homepage: https://github.com/mer-hybris/libgbinder
Vcs-Browser: https://source.puri.sm/Librem5/debs/libgbinder
Vcs-Git: https://source.puri.sm/Librem5/debs/libgbinder.git

Package: libgbinder1
Section: libs
Architecture: any
Depends: libglibutil1 (>= 1.0.52), ${shlibs:Depends}, ${misc:Depends}
Replaces: libgbinder
Breaks: libgbinder
Description: Binder client library
 GLib-based library for interfacing with Android's Binder.

Package: libgbinder-dev
Section: libdevel
Architecture: any
Depends: libgbinder1 (= ${binary:Version}), libglibutil-dev (>= 1.0.52), ${misc:Depends}
Description: Development files for libgbinder
 GLib-based library for interfacing with Android's Binder.

Package: libgbinder-tools
Section: utils
Architecture: any
Depends: libgbinder1, ${shlibs:Depends}, ${misc:Depends}
Description: Binder command line utilities
 GLib-based library for interfacing with Android's Binder.

=== debian/rules ===
--- 
+++ 
@@ -1,5 +1,7 @@
 #!/usr/bin/make -f
 # -*- makefile -*-
+
+include /usr/share/dpkg/pkg-info.mk
 
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
@@ -7,7 +9,7 @@
 LIBDIR=usr/lib/$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 
 override_dh_auto_build:
-	dh_auto_build -- LIBDIR=$(LIBDIR) release pkgconfig debian/libgbinder.install debian/libgbinder-dev.install
+	dh_auto_build -- LIBDIR=$(LIBDIR) release pkgconfig debian/libgbinder1.install debian/libgbinder-dev.install
 	dh_auto_build -- -C test/binder-bridge release
 	dh_auto_build -- -C test/binder-call release
 	dh_auto_build -- -C test/binder-list release
@@ -20,5 +22,11 @@
 	dh_auto_install -- -C test/binder-list
 	dh_auto_install -- -C test/binder-ping
 
+
+execute_before_dh_installman:
+	for n in debian/tmp/usr/bin/binder-*; do \
+		LD_LIBRARY_PATH=debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH):$(LD_LIBRARY_PATH) help2man -n "testing tool for libgbinder" -N --version-string='$(DEB_VERSION_UPSTREAM)' "$$n" > debian/$${n##*/}.1; \
+	done
+
 %:
 	dh $@
